; ..............................................................................
;    File   LowPassFilter.s
; ..............................................................................

		.equ LowPassNumTaps, 256

; ..............................................................................
; Allocate and initialize filter taps

		.section .xdata
		.align 512

LowPassTaps:
.hword 	0x0000,	0x0000,	0xFFFF,	0xFFFF,	0x0000,	0x0002,	0x0004,	0x0005,	0x0002
.hword 	0xFFFF,	0xFFFB,	0xFFF9,	0xFFFA,	0x0000,	0x0005,	0x000B,	0x000B,	0x0007
.hword 	0xFFFF,	0xFFF6,	0xFFF1,	0xFFF4,	0xFFFD,	0x0008,	0x0012,	0x0014,	0x000D
.hword 	0x0000,	0xFFF1,	0xFFE9,	0xFFEB,	0xFFF8,	0x0009,	0x0019,	0x001E,	0x0015
.hword 	0x0002,	0xFFED,	0xFFDF,	0xFFE0,	0xFFF1,	0x000A,	0x0021,	0x002A,	0x0020
.hword 	0x0007,	0xFFE9,	0xFFD3,	0xFFD2,	0xFFE6,	0x0008,	0x0029,	0x0039,	0x002F
.hword 	0x000F,	0xFFE6,	0xFFC6,	0xFFC0,	0xFFD8,	0x0003,	0x0031,	0x004B,	0x0043
.hword 	0x001B,	0xFFE5,	0xFFB7,	0xFFA9,	0xFFC3,	0xFFFC,	0x003A,	0x0062,	0x005E
.hword 	0x002E,	0xFFE6,	0xFFA5,	0xFF8B,	0xFFA7,	0xFFEF,	0x0043,	0x007F,	0x0083
.hword 	0x004A,	0xFFEB,	0xFF8F,	0xFF62,	0xFF7C,	0xFFD7,	0x004C,	0x00A6,	0x00B9
.hword 	0x0076,	0xFFF7,	0xFF71,	0xFF25,	0xFF3A,	0xFFB0,	0x0055,	0x00E1,	0x010F
.hword 	0x00C0,	0x000F,	0xFF46,	0xFEC1,	0xFEC7,	0xFF65,	0x005E,	0x0147,	0x01AE
.hword 	0x0152,	0x0047,	0xFEF7,	0xFDF7,	0xFDD0,	0xFEB7,	0x0066,	0x0232,	0x033F
.hword 	0x02E2,	0x00F9,	0xFE14,	0xFB59,	0xFA30,	0xFBC0,	0x006F,	0x07A9,	0x0FEC
.hword 	0x1732,	0x1B8C,	0x1B8C,	0x1732,	0x0FEC,	0x07A9,	0x006F,	0xFBC0,	0xFA30
.hword 	0xFB59,	0xFE14,	0x00F9,	0x02E2,	0x033F,	0x0232,	0x0066,	0xFEB7,	0xFDD0
.hword 	0xFDF7,	0xFEF7,	0x0047,	0x0152,	0x01AE,	0x0147,	0x005E,	0xFF65,	0xFEC7
.hword 	0xFEC1,	0xFF46,	0x000F,	0x00C0,	0x010F,	0x00E1,	0x0055,	0xFFB0,	0xFF3A
.hword 	0xFF25,	0xFF71,	0xFFF7,	0x0076,	0x00B9,	0x00A6,	0x004C,	0xFFD7,	0xFF7C
.hword 	0xFF62,	0xFF8F,	0xFFEB,	0x004A,	0x0083,	0x007F,	0x0043,	0xFFEF,	0xFFA7
.hword 	0xFF8B,	0xFFA5,	0xFFE6,	0x002E,	0x005E,	0x0062,	0x003A,	0xFFFC,	0xFFC3
.hword 	0xFFA9,	0xFFB7,	0xFFE5,	0x001B,	0x0043,	0x004B,	0x0031,	0x0003,	0xFFD8
.hword 	0xFFC0,	0xFFC6,	0xFFE6,	0x000F,	0x002F,	0x0039,	0x0029,	0x0008,	0xFFE6
.hword 	0xFFD2,	0xFFD3,	0xFFE9,	0x0007,	0x0020,	0x002A,	0x0021,	0x000A,	0xFFF1
.hword 	0xFFE0,	0xFFDF,	0xFFED,	0x0002,	0x0015,	0x001E,	0x0019,	0x0009,	0xFFF8
.hword 	0xFFEB,	0xFFE9,	0xFFF1,	0x0000,	0x000D,	0x0014,	0x0012,	0x0008,	0xFFFD
.hword 	0xFFF4,	0xFFF1,	0xFFF6,	0xFFFF,	0x0007,	0x000B,	0x000B,	0x0005,	0x0000
.hword 	0xFFFA,	0xFFF9,	0xFFFB,	0xFFFF,	0x0002,	0x0005,	0x0004,	0x0002,	0x0000
.hword 	0xFFFF,	0xFFFF,	0x0000,	0x0000

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss,  "b"
		.align 512

LowPassDelay:
		.space LowPassNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _LowPassFilter

_LowPassFilter:
.hword LowPassNumTaps
.hword LowPassTaps
.hword LowPassTaps+LowPassNumTaps*2-1
.hword 0xff00
.hword LowPassDelay
.hword LowPassDelay+LowPassNumTaps*2-1
.hword LowPassDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_BlockFIRFilter
;		.extern	_LowPassFilterFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 4)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_LowPassFilterFilter, W0	; Initalize W0 to filter structure
;		call	_FIRFilterInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _BlockFIRFilter
;		mov	#_LowPassFilterFilter, W0	; Initalize W0 to filter structure
;		mov	#input, W1	; Initalize W1 to input buffer 
;		mov	#output, W2	; Initalize W2 to output buffer
;		mov	#20, W3	; Initialize W3 with number of required output samples
;		call	_BlockFIRFilter	; call as many times as needed
